Index: t3lib/class.t3lib_div.php
===================================================================
--- t3lib/class.t3lib_div.php	(revision 9354)
+++ t3lib/class.t3lib_div.php	(revision )
@@ -1447,11 +1491,11 @@
 	 * @param	string		Value where &gt;, &lt;, &quot; and &amp; should be converted to regular chars.
 	 * @return	string		Converted result.
 	 */
-	public static function htmlspecialchars_decode($value)	{
+	public static function htmlspecialchars_decode($value) {
-		$value = str_replace('&gt;','>',$value);
+		$value = str_replace('&gt;', '>', $value);
-		$value = str_replace('&lt;','<',$value);
+		$value = str_replace('&lt;', '<', $value);
-		$value = str_replace('&quot;','"',$value);
+		$value = str_replace('&quot;', '"', $value);
-		$value = str_replace('&amp;','&',$value);
+		$value = str_replace('&amp;', '&', $value);
 		return $value;
 	}
 
@@ -1462,8 +1506,8 @@
 	 * @param	string		String which contains eg. "&amp;amp;" which should stay "&amp;". Or "&amp;#1234;" to "&#1234;". Or "&amp;#x1b;" to "&#x1b;"
 	 * @return	string		Converted result.
 	 */
-	public static function deHSCentities($str)	{
+	public static function deHSCentities($str) {
-		return preg_replace('/&amp;([#[:alnum:]]*;)/','&\1',$str);
+		return preg_replace('/&amp;([#[:alnum:]]*;)/', '&\1', $str);
 	}
 
 	/**
@@ -1475,9 +1519,11 @@
 	 * @param	string		The character to escape, default is ' (single-quote)
 	 * @return	string		Processed input string
 	 */
-	public static function slashJS($string,$extended=0,$char="'")	{
+	public static function slashJS($string, $extended = 0, $char = "'") {
-		if ($extended)	{$string = str_replace ("\\", "\\\\", $string);}
+		if ($extended) {
+			$string = str_replace("\\", "\\\\", $string);
+		}
-		return str_replace ($char, "\\".$char, $string);
+		return str_replace($char, "\\" . $char, $string);
 	}
 
 	/**
@@ -1488,8 +1534,8 @@
 	 * @param	string		String to raw-url-encode with spaces preserved
 	 * @return	string		Rawurlencoded result of input string, but with all %20 (space chars) converted to real spaces.
 	 */
-	public static function rawUrlEncodeJS($str)	{
+	public static function rawUrlEncodeJS($str) {
-		return str_replace('%20',' ',rawurlencode($str));
+		return str_replace('%20', ' ', rawurlencode($str));
 	}
 
 	/**
@@ -1500,8 +1546,8 @@
 	 * @param	string		Input string
 	 * @return	string		Output string
 	 */
-	public static function rawUrlEncodeFP($str)	{
+	public static function rawUrlEncodeFP($str) {
-		return str_replace('%2F','/',rawurlencode($str));
+		return str_replace('%2F', '/', rawurlencode($str));
 	}
 
 	/**
@@ -1511,7 +1557,7 @@
 	 * @param	string		Input string to evaluate
 	 * @return	boolean		Returns true if the $email address (input string) is valid
 	 */
-	public static function validEmail($email)	{
+	public static function validEmail($email) {
 			// enforce maximum length to prevent libpcre recursion crash bug #52929 in PHP
 			// fixed in PHP 5.2+ later than Sept 2010; length restriction per SMTP RFC 2821
 		if (strlen($email) > 320) {
@@ -1533,7 +1579,7 @@
 	 * @return	boolean	true if mail() does not accept recipient name
 	 */
 	public static function isBrokenEmailEnvironment() {
-		return TYPO3_OS == 'WIN' || (false !== strpos(ini_get('sendmail_path'), 'mini_sendmail'));
+		return TYPO3_OS == 'WIN' || (FALSE !== strpos(ini_get('sendmail_path'), 'mini_sendmail'));
 	}
 
 	/**
@@ -1544,7 +1590,7 @@
 	 * @see	t3lib_::isBrokenEmailEnvironment()
 	 */
 	public static function normalizeMailAddress($address) {
-		if (self::isBrokenEmailEnvironment() && false !== ($pos1 = strrpos($address, '<'))) {
+		if (self::isBrokenEmailEnvironment() && FALSE !== ($pos1 = strrpos($address, '<'))) {
 			$pos2 = strpos($address, '>', $pos1);
 			$address = substr($address, $pos1 + 1, ($pos2 ? $pos2 : strlen($address)) - $pos1 - 1);
 		}
@@ -1560,8 +1606,8 @@
 	 * @param	string		Input string to be formatted.
 	 * @return	string		Formatted for <textarea>-tags
 	 */
-	public static function formatForTextarea($content)	{
+	public static function formatForTextarea($content) {
-		return LF.htmlspecialchars($content);
+		return LF . htmlspecialchars($content);
 	}
 
 	/**
@@ -1570,11 +1616,11 @@
 	 * uppercase. It is safe for all supported character sets (incl. utf-8).
 	 * Unlike strtoupper() it does not honour the locale.
 	 *
-	 * @param   string      Input string
+	 * @param   string	  Input string
-	 * @return  string      Uppercase String
+	 * @return  string	  Uppercase String
 	 */
 	public static function strtoupper($str) {
-		return strtr((string)$str, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
+		return strtr((string) $str, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
 	}
 
 	/**
@@ -1586,8 +1632,8 @@
 	 * @param	string		Input string
 	 * @return	string		Lowercase String
 	 */
-	public static function strtolower($str)	{
+	public static function strtolower($str) {
-		return strtr((string)$str, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz');
+		return strtr((string) $str, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz');
 	}
 
 	/**
@@ -1610,7 +1656,7 @@
 				try {
 					$com = new COM('CAPICOM.Utilities.1');
 					$output = base64_decode($com->GetRandom($count, 0));
-				} catch(Exception $e) {
+				} catch (Exception $e) {
 					// CAPICOM not installed
 				}
 			}
@@ -1618,7 +1664,7 @@
 				if (function_exists('mcrypt_create_iv')) {
 					$output = mcrypt_create_iv($count, MCRYPT_DEV_URANDOM);
 				} elseif (function_exists('openssl_random_pseudo_bytes')) {
-					$isStrong = null;
+					$isStrong = NULL;
 					$output = openssl_random_pseudo_bytes($count, $isStrong);
 						// skip ssl since it wasn't using the strong algo
 					if ($isStrong !== TRUE) {
@@ -1632,11 +1678,11 @@
 		if (!isset($output{$count - 1})) {
 				// We initialize with the somewhat random.
 			$randomState = $GLOBALS['TYPO3_CONF_VARS']['SYS']['encryptionKey']
-							. base_convert(memory_get_usage() % pow(10, 6), 10, 2)
-							. microtime() . uniqid('') . getmypid();
+					. base_convert(memory_get_usage() % pow(10, 6), 10, 2)
+					. microtime() . uniqid('') . getmypid();
 			while (!isset($output{$count - 1})) {
 				$randomState = sha1(microtime() . mt_rand() . $randomState);
-				$output .= sha1(mt_rand() . $randomState, true);
+				$output .= sha1(mt_rand() . $randomState, TRUE);
 			}
 			$output = substr($output, strlen($output) - $count, $count);
 		}
@@ -1707,18 +1753,10 @@
 	 * @return	boolean		Whether the given URL is valid
 	 */
 	public static function isValidUrl($url) {
-		return (filter_var($url, FILTER_VALIDATE_URL, FILTER_FLAG_SCHEME_REQUIRED) !== false);
+		return (filter_var($url, FILTER_VALIDATE_URL, FILTER_FLAG_SCHEME_REQUIRED) !== FALSE);
 	}
 
 
-
-
-
-
-
-
-
-
 	/*************************
 	 *
 	 * ARRAY FUNCTIONS
@@ -1737,10 +1775,10 @@
 	 * +---------+-----------+-----------+-----------+
 	 * | $needle | variant_a | variant_b | variant_c |
 	 * +---------+-----------+-----------+-----------+
-	 * | '1a'    | false     | true      | false     |
+	 * | '1a'	| false	 | true	  | false	 |
-	 * | ''      | false     | true      | false     |
+	 * | ''	  | false	 | true	  | false	 |
-	 * | '0'     | true      | true      | false     |
+	 * | '0'	 | true	  | true	  | false	 |
-	 * | 0       | true      | true      | true      |
+	 * | 0	   | true	  | true	  | true	  |
 	 * +---------+-----------+-----------+-----------+
 	 * Usage: 3
 	 *
@@ -1751,10 +1789,10 @@
 	public static function inArray(array $in_array, $item) {
 		foreach ($in_array as $val) {
 			if (!is_array($val) && !strcmp($val, $item)) {
-				return true;
+				return TRUE;
 			}
 		}
-		return false;
+		return FALSE;
 	}
 
 	/**
@@ -1766,8 +1804,8 @@
 	 * @param	string		The string to explode
 	 * @param	boolean		If set, all empty values (='') will NOT be set in output
 	 * @param	integer		If positive, the result will contain a maximum of limit elements,
-	 * 						if negative, all components except the last -limit are returned,
+	 *						 if negative, all components except the last -limit are returned,
-	 * 						if zero (default), the result is not limited at all
+	 *						 if zero (default), the result is not limited at all
 	 * @return	array		Exploded values, all converted to integers
 	 */
 	public static function intExplode($delimiter, $string, $onlyNonEmptyValues = FALSE, $limit = 0) {
@@ -1785,7 +1823,7 @@
 	 * @param	integer		Number of array entries
 	 * @return	array		Exploded values
 	 */
-	public static function revExplode($delimiter, $string, $count=0) {
+	public static function revExplode($delimiter, $string, $count = 0) {
 		$explodedValues = explode($delimiter, strrev($string), $count);
 		$explodedValues = array_map('strrev', $explodedValues);
 		return array_reverse($explodedValues);
@@ -1800,21 +1838,21 @@
 	 * @param	string		The string to explode
 	 * @param	boolean		If set, all empty values will be removed in output
 	 * @param	integer		If positive, the result will contain a maximum of
-	 * 						$limit elements, if negative, all components except
+	 *						 $limit elements, if negative, all components except
-	 * 						the last -$limit are returned, if zero (default),
+	 *						 the last -$limit are returned, if zero (default),
-	 * 						the result is not limited at all. Attention though
+	 *						 the result is not limited at all. Attention though
-	 * 						that the use of this parameter can slow down this
+	 *						 that the use of this parameter can slow down this
-	 * 						function.
+	 *						 function.
 	 * @return	array		Exploded values
 	 */
-	public static function trimExplode($delim, $string, $removeEmptyValues = false, $limit = 0) {
+	public static function trimExplode($delim, $string, $removeEmptyValues = FALSE, $limit = 0) {
 		$explodedValues = explode($delim, $string);
 
 		$result = array_map('trim', $explodedValues);
 
 		if ($removeEmptyValues) {
 			$temp = array();
-			foreach($result as $value) {
+			foreach ($result as $value) {
 				if ($value !== '') {
 					$temp[] = $value;
 				}
@@ -1844,7 +1882,7 @@
 	 * @ignore
 	 * @deprecated since TYPO3 3.5, will be removed in TYPO3 4.6 - Use the PHP function array_unique instead
 	 */
-	public static function uniqueArray(array $valueArray)	{
+	public static function uniqueArray(array $valueArray) {
 		self::logDeprecatedFunction();
 
 		return array_unique($valueArray);
@@ -1858,7 +1896,7 @@
 	 * @param	string		Value to search for and if found remove array entry where found.
 	 * @return	array		Output array with entries removed if search string is found
 	 */
-	public static function removeArrayEntryByValue(array $array, $cmpValue)	{
+	public static function removeArrayEntryByValue(array $array, $cmpValue) {
 		foreach ($array as $k => $v) {
 			if (is_array($v)) {
 				$array[$k] = self::removeArrayEntryByValue($v, $cmpValue);
@@ -1875,16 +1913,16 @@
 	 *
 	 * Example (arguments used to call this function):
 	 * $array = array(
-	 * 		array('aa' => array('first', 'second'),
+	 *		 array('aa' => array('first', 'second'),
-	 * 		array('bb' => array('third', 'fourth'),
+	 *		 array('bb' => array('third', 'fourth'),
-	 * 		array('cc' => array('fifth', 'sixth'),
+	 *		 array('cc' => array('fifth', 'sixth'),
 	 * );
 	 * $keepItems = array('third');
 	 * $getValueFunc = create_function('$value', 'return $value[0];');
 	 *
 	 * Returns:
 	 * array(
-	 * 		array('bb' => array('third', 'fourth'),
+	 *		 array('bb' => array('third', 'fourth'),
 	 * )
 	 *
 	 * @param	array		$array: The initial array to be filtered/reduced
@@ -1892,7 +1930,7 @@
 	 * @param	string		$getValueFunc: (optional) Unique function name set by create_function() used to get the value to keep
 	 * @return	array		The filtered/reduced array with the kept items
 	 */
-	public static function keepItemsInArray(array $array, $keepItems, $getValueFunc=null) {
+	public static function keepItemsInArray(array $array, $keepItems, $getValueFunc = NULL) {
 		if ($array) {
 				// Convert strings to arrays:
 			if (is_string($keepItems)) {
@@ -1900,7 +1938,7 @@
 			}
 				// create_function() returns a string:
 			if (!is_string($getValueFunc)) {
-				$getValueFunc = null;
+				$getValueFunc = NULL;
 			}
 				// Do the filtering:
 			if (is_array($keepItems) && count($keepItems)) {
@@ -1928,15 +1966,15 @@
 	 * @return	string		Imploded result, fx. &param[key][key2]=value2&param[key][key3]=value3
 	 * @see explodeUrl2Array()
 	 */
-	public static function implodeArrayForUrl($name, array $theArray, $str = '', $skipBlank = false, $rawurlencodeParamName = false) {
+	public static function implodeArrayForUrl($name, array $theArray, $str = '', $skipBlank = FALSE, $rawurlencodeParamName = FALSE) {
-		foreach($theArray as $Akey => $AVal)	{
+		foreach ($theArray as $Akey => $AVal) {
-			$thisKeyName = $name ? $name.'['.$Akey.']' : $Akey;
+			$thisKeyName = $name ? $name . '[' . $Akey . ']' : $Akey;
-			if (is_array($AVal))	{
+			if (is_array($AVal)) {
-				$str = self::implodeArrayForUrl($thisKeyName,$AVal,$str,$skipBlank,$rawurlencodeParamName);
+				$str = self::implodeArrayForUrl($thisKeyName, $AVal, $str, $skipBlank, $rawurlencodeParamName);
 			} else {
-				if (!$skipBlank || strcmp($AVal,''))	{
+				if (!$skipBlank || strcmp($AVal, '')) {
-					$str.='&'.($rawurlencodeParamName ? rawurlencode($thisKeyName) : $thisKeyName).
+					$str .= '&' . ($rawurlencodeParamName ? rawurlencode($thisKeyName) : $thisKeyName) .
-						'='.rawurlencode($AVal);
+							'=' . rawurlencode($AVal);
 				}
 			}
 		}
@@ -1951,15 +1989,15 @@
 	 * @return	array		Array of values. All values AND keys are rawurldecoded() as they properly should be. But this means that any implosion of the array again must rawurlencode it!
 	 * @see implodeArrayForUrl()
 	 */
-	public static function explodeUrl2Array($string,$multidim=FALSE)	{
+	public static function explodeUrl2Array($string, $multidim = FALSE) {
 		$output = array();
-		if ($multidim)	{
+		if ($multidim) {
-			parse_str($string,$output);
+			parse_str($string, $output);
 		} else {
-			$p = explode('&',$string);
+			$p = explode('&', $string);
-			foreach($p as $v)	{
+			foreach ($p as $v) {
-				if (strlen($v))	{
+				if (strlen($v)) {
-					list($pK,$pV) = explode('=',$v,2);
+					list($pK, $pV) = explode('=', $v, 2);
 					$output[rawurldecode($pK)] = rawurldecode($pV);
 				}
 			}
@@ -1977,11 +2015,11 @@
 	 * @param	boolean		If set, then t3lib_div::_GP() is used to fetch the value if not found (isset) in the $getArray
 	 * @return	array		Output array with selected variables.
 	 */
-	public static function compileSelectedGetVarsFromArray($varList,array $getArray,$GPvarAlt=1)	{
+	public static function compileSelectedGetVarsFromArray($varList, array $getArray, $GPvarAlt = 1) {
-		$keys = self::trimExplode(',',$varList,1);
+		$keys = self::trimExplode(',', $varList, 1);
 		$outArr = array();
-		foreach($keys as $v)	{
+		foreach ($keys as $v) {
-			if (isset($getArray[$v]))	{
+			if (isset($getArray[$v])) {
 				$outArr[$v] = $getArray[$v];
 			} elseif ($GPvarAlt) {
 				$outArr[$v] = self::_GP($v);
@@ -2000,7 +2038,7 @@
 	 * @param	array		Multidimensional input array, (REFERENCE!)
 	 * @return	array
 	 */
-	public static function addSlashesOnArray(array &$theArray)	{
+	public static function addSlashesOnArray(array &$theArray) {
 		foreach ($theArray as &$value) {
 			if (is_array($value)) {
 				self::addSlashesOnArray($value);
@@ -2022,7 +2060,7 @@
 	 * @param	array		Multidimensional input array, (REFERENCE!)
 	 * @return	array
 	 */
-	public static function stripSlashesOnArray(array &$theArray)	{
+	public static function stripSlashesOnArray(array &$theArray) {
 		foreach ($theArray as &$value) {
 			if (is_array($value)) {
 				self::stripSlashesOnArray($value);
@@ -2042,17 +2080,21 @@
 	 * @param	string		"add" or "strip", depending on usage you wish.
 	 * @return	array
 	 */
-	public static function slashArray(array $arr,$cmd)	{
+	public static function slashArray(array $arr, $cmd) {
-		if ($cmd=='strip')	self::stripSlashesOnArray($arr);
-		if ($cmd=='add')	self::addSlashesOnArray($arr);
+		if ($cmd == 'strip') {
+			self::stripSlashesOnArray($arr);
+		}
+		if ($cmd == 'add') {
+			self::addSlashesOnArray($arr);
+		}
 		return $arr;
 	}
 
 	/**
-	* Rename Array keys with a given mapping table
-	* @param	array	Array by reference which should be remapped
-	* @param	array	Array with remap information, array/$oldKey => $newKey)
-	*/
+	 * Rename Array keys with a given mapping table
+	 * @param	array	Array by reference which should be remapped
+	 * @param	array	Array with remap information, array/$oldKey => $newKey)
+	 */
 	function remapArrayKeys(&$array, $mappingTable) {
 		if (is_array($mappingTable)) {
 			foreach ($mappingTable as $old => $new) {
@@ -2078,11 +2120,11 @@
 	 * @param	boolean		If set, values from $arr1 will overrule if they are empty or zero. Default: true
 	 * @return	array		Resulting array where $arr1 values has overruled $arr0 values
 	 */
-	public static function array_merge_recursive_overrule(array $arr0,array $arr1,$notAddKeys=0,$includeEmtpyValues=true) {
+	public static function array_merge_recursive_overrule(array $arr0, array $arr1, $notAddKeys = 0, $includeEmtpyValues = TRUE) {
 		foreach ($arr1 as $key => $val) {
-			if(is_array($arr0[$key])) {
+			if (is_array($arr0[$key])) {
-				if (is_array($arr1[$key]))	{
+				if (is_array($arr1[$key])) {
-					$arr0[$key] = self::array_merge_recursive_overrule($arr0[$key],$arr1[$key],$notAddKeys,$includeEmtpyValues);
+					$arr0[$key] = self::array_merge_recursive_overrule($arr0[$key], $arr1[$key], $notAddKeys, $includeEmtpyValues);
 				}
 			} else {
 				if ($notAddKeys) {
@@ -2110,8 +2152,8 @@
 	 * @param	array		Second array
 	 * @return	array		Merged result.
 	 */
-	public static function array_merge(array $arr1,array $arr2)	{
+	public static function array_merge(array $arr1, array $arr2) {
-		return $arr2+$arr1;
+		return $arr2 + $arr1;
 	}
 
 	/**
@@ -2146,13 +2188,13 @@
 	 * @param	string		Quote-character to wrap around the values.
 	 * @return	string		A single line of CSV
 	 */
-	public static function csvValues(array $row,$delim=',',$quote='"')	{
+	public static function csvValues(array $row, $delim = ',', $quote = '"') {
 		reset($row);
-		$out=array();
+		$out = array();
 		foreach ($row as $value) {
-			$out[] = str_replace($quote, $quote.$quote, $value);
+			$out[] = str_replace($quote, $quote . $quote, $value);
 		}
-		$str = $quote.implode($quote.$delim.$quote,$out).$quote;
+		$str = $quote . implode($quote . $delim . $quote, $out) . $quote;
 		return $str;
 	}
 
@@ -2208,11 +2250,6 @@
 	}
 
 
-
-
-
-
-
 	/*************************
 	 *
 	 * HTML/XML PROCESSING
@@ -2228,27 +2265,27 @@
 	 * @param	string		HTML-tag string (or attributes only)
 	 * @return	array		Array with the attribute values.
 	 */
-	public static function get_tag_attributes($tag)	{
+	public static function get_tag_attributes($tag) {
 		$components = self::split_tag_attributes($tag);
-		$name = '';	 // attribute name is stored here
+		$name = ''; // attribute name is stored here
-		$valuemode = false;
+		$valuemode = FALSE;
 		$attributes = array();
-		foreach ($components as $key => $val)	{
+		foreach ($components as $key => $val) {
-			if ($val != '=')	{	// Only if $name is set (if there is an attribute, that waits for a value), that valuemode is enabled. This ensures that the attribute is assigned it's value
+			if ($val != '=') { // Only if $name is set (if there is an attribute, that waits for a value), that valuemode is enabled. This ensures that the attribute is assigned it's value
-				if ($valuemode)	{
+				if ($valuemode) {
-					if ($name)	{
+					if ($name) {
 						$attributes[$name] = $val;
 						$name = '';
 					}
 				} else {
-					if ($key = strtolower(preg_replace('/[^a-zA-Z0-9]/','',$val)))	{
+					if ($key = strtolower(preg_replace('/[^a-zA-Z0-9]/', '', $val))) {
 						$attributes[$key] = '';
 						$name = $key;
 					}
 				}
-				$valuemode = false;
+				$valuemode = FALSE;
 			} else {
-				$valuemode = true;
+				$valuemode = TRUE;
 			}
 		}
 		return $attributes;
@@ -2262,26 +2299,26 @@
 	 * @param	string		HTML-tag string (or attributes only)
 	 * @return	array		Array with the attribute values.
 	 */
-	public static function split_tag_attributes($tag)	{
+	public static function split_tag_attributes($tag) {
-		$tag_tmp = trim(preg_replace('/^<[^[:space:]]*/','',trim($tag)));
+		$tag_tmp = trim(preg_replace('/^<[^[:space:]]*/', '', trim($tag)));
 			// Removes any > in the end of the string
 		$tag_tmp = trim(rtrim($tag_tmp, '>'));
 
 		$value = array();
-		while (strcmp($tag_tmp,''))	{	// Compared with empty string instead , 030102
+		while (strcmp($tag_tmp, '')) { // Compared with empty string instead , 030102
-			$firstChar=substr($tag_tmp,0,1);
+			$firstChar = substr($tag_tmp, 0, 1);
-			if (!strcmp($firstChar,'"') || !strcmp($firstChar,"'"))	{
+			if (!strcmp($firstChar, '"') || !strcmp($firstChar, "'")) {
-				$reg=explode($firstChar,$tag_tmp,3);
+				$reg = explode($firstChar, $tag_tmp, 3);
-				$value[]=$reg[1];
+				$value[] = $reg[1];
-				$tag_tmp=trim($reg[2]);
+				$tag_tmp = trim($reg[2]);
-			} elseif (!strcmp($firstChar,'=')) {
+			} elseif (!strcmp($firstChar, '=')) {
 				$value[] = '=';
-				$tag_tmp = trim(substr($tag_tmp,1));		// Removes = chars.
+				$tag_tmp = trim(substr($tag_tmp, 1)); // Removes = chars.
 			} else {
 					// There are '' around the value. We look for the next ' ' or '>'
 				$reg = preg_split('/[[:space:]=]/', $tag_tmp, 2);
 				$value[] = trim($reg[0]);
-				$tag_tmp = trim(substr($tag_tmp,strlen($reg[0]),1).$reg[1]);
+				$tag_tmp = trim(substr($tag_tmp, strlen($reg[0]), 1) . $reg[1]);
 			}
 		}
 		reset($value);
@@ -2297,19 +2334,23 @@
 	 * @param	boolean		If true, don't check if values are blank. Default is to omit attributes with blank values.
 	 * @return	string		Imploded attributes, eg. 'bgcolor="red" border="0"'
 	 */
-	public static function implodeAttributes(array $arr,$xhtmlSafe=FALSE,$dontOmitBlankAttribs=FALSE)	{
+	public static function implodeAttributes(array $arr, $xhtmlSafe = FALSE, $dontOmitBlankAttribs = FALSE) {
-		if ($xhtmlSafe)	{
+		if ($xhtmlSafe) {
-			$newArr=array();
+			$newArr = array();
-			foreach($arr as $p => $v)	{
+			foreach ($arr as $p => $v) {
-				if (!isset($newArr[strtolower($p)])) $newArr[strtolower($p)] = htmlspecialchars($v);
+				if (!isset($newArr[strtolower($p)])) {
+					$newArr[strtolower($p)] = htmlspecialchars($v);
-			}
+				}
+			}
 			$arr = $newArr;
 		}
 		$list = array();
-		foreach($arr as $p => $v)	{
+		foreach ($arr as $p => $v) {
-			if (strcmp($v,'') || $dontOmitBlankAttribs)	{$list[]=$p.'="'.$v.'"';}
+			if (strcmp($v, '') || $dontOmitBlankAttribs) {
+				$list[] = $p . '="' . $v . '"';
-		}
+			}
+		}
-		return implode(' ',$list);
+		return implode(' ', $list);
 	}
 
 	/**
@@ -2322,10 +2363,10 @@
 	 * @deprecated since TYPO3 3.7, will be removed in TYPO3 4.6 - Name was changed into implodeAttributes
 	 * @see implodeAttributes()
 	 */
-	public static function implodeParams(array $arr,$xhtmlSafe=FALSE,$dontOmitBlankAttribs=FALSE)	{
+	public static function implodeParams(array $arr, $xhtmlSafe = FALSE, $dontOmitBlankAttribs = FALSE) {
 		self::logDeprecatedFunction();
 
-		return self::implodeAttributes($arr,$xhtmlSafe,$dontOmitBlankAttribs);
+		return self::implodeAttributes($arr, $xhtmlSafe, $dontOmitBlankAttribs);
 	}
 
 	/**
@@ -2339,23 +2380,23 @@
 	 * @author	Ingmar Schlecht <ingmars@web.de>
 	 * @author	René Fritz <r.fritz@colorcube.de>
 	 */
-	public static function wrapJS($string, $linebreak=TRUE) {
+	public static function wrapJS($string, $linebreak = TRUE) {
-		if(trim($string)) {
+		if (trim($string)) {
 				// <script wrapped in nl?
-			$cr = $linebreak? LF : '';
+			$cr = $linebreak ? LF : '';
 
 				// remove nl from the beginning
-			$string = preg_replace ('/^\n+/', '', $string);
+			$string = preg_replace('/^\n+/', '', $string);
 				// re-ident to one tab using the first line as reference
 			$match = array();
-			if(preg_match('/^(\t+)/',$string,$match)) {
+			if (preg_match('/^(\t+)/', $string, $match)) {
-				$string = str_replace($match[1],TAB, $string);
+				$string = str_replace($match[1], TAB, $string);
 			}
-			$string = $cr.'<script type="text/javascript">
+			$string = $cr . '<script type="text/javascript">
 /*<![CDATA[*/
-'.$string.'
+' . $string . '
 /*]]>*/
-</script>'.$cr;
+</script>' . $cr;
 		}
 		return trim($string);
 	}
@@ -2370,7 +2411,7 @@
 	 * @return	mixed		The array with the parsed structure unless the XML parser returns with an error in which case the error message string is returned.
 	 * @author bisqwit at iki dot fi dot not dot for dot ads dot invalid / http://dk.php.net/xml_parse_into_struct + kasperYYYY@typo3.com
 	 */
-	public static function xml2tree($string,$depth=999) {
+	public static function xml2tree($string, $depth = 999) {
 		$parser = xml_parser_create();
 		$vals = array();
 		$index = array();
@@ -2379,49 +2420,54 @@
 		xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 0);
 		xml_parse_into_struct($parser, $string, $vals, $index);
 
-		if (xml_get_error_code($parser))	return 'Line '.xml_get_current_line_number($parser).': '.xml_error_string(xml_get_error_code($parser));
+		if (xml_get_error_code($parser)) {
+			return 'Line ' . xml_get_current_line_number($parser) . ': ' . xml_error_string(xml_get_error_code($parser));
+		}
 		xml_parser_free($parser);
 
-		$stack = array( array() );
+		$stack = array(array());
 		$stacktop = 0;
-		$startPoint=0;
+		$startPoint = 0;
 
-// FIXME don't use unset() - what does that mean? Use NULL or similar.
-		unset($tagi);
+		$tagi = array();
-		foreach($vals as $key => $val) {
+		foreach ($vals as $key => $val) {
 			$type = $val['type'];
 
 				// open tag:
-			if ($type=='open' || $type=='complete') {
+			if ($type == 'open' || $type == 'complete') {
 				$stack[$stacktop++] = $tagi;
 
-				if ($depth==$stacktop)	{
+				if ($depth == $stacktop) {
-					$startPoint=$key;
+					$startPoint = $key;
 				}
 
 				$tagi = array('tag' => $val['tag']);
 
-				if(isset($val['attributes']))  $tagi['attrs'] = $val['attributes'];
-				if(isset($val['value']))	$tagi['values'][] = $val['value'];
+				if (isset($val['attributes'])) {
+					$tagi['attrs'] = $val['attributes'];
-			}
+				}
+				if (isset($val['value'])) {
+					$tagi['values'][] = $val['value'];
+				}
+			}
 				// finish tag:
-			if ($type=='complete' || $type=='close')	{
+			if ($type == 'complete' || $type == 'close') {
 				$oldtagi = $tagi;
 				$tagi = $stack[--$stacktop];
 				$oldtag = $oldtagi['tag'];
 				unset($oldtagi['tag']);
 
-				if ($depth==($stacktop+1))	{
+				if ($depth == ($stacktop + 1)) {
-					if ($key-$startPoint > 0)	{
+					if ($key - $startPoint > 0) {
 						$partArray = array_slice(
 							$vals,
-							$startPoint+1,
+								$startPoint + 1,
-							$key-$startPoint-1
+								$key - $startPoint - 1
 						);
 						#$oldtagi=array('XMLvalue'=>self::xmlRecompileFromStructValArray($partArray));
-						$oldtagi['XMLvalue']=self::xmlRecompileFromStructValArray($partArray);
+						$oldtagi['XMLvalue'] = self::xmlRecompileFromStructValArray($partArray);
 					} else {
-						$oldtagi['XMLvalue']=$oldtagi['values'][0];
+						$oldtagi['XMLvalue'] = $oldtagi['values'][0];
 					}
 				}
 
@@ -2429,7 +2475,7 @@
 				unset($oldtagi);
 			}
 				// cdata
-			if($type=='cdata') {
+			if ($type == 'cdata') {
 				$tagi['values'][] = $val['value'];
 			}
 		}
@@ -2446,22 +2492,22 @@
 	 * @return	string		An XML string made from the input content in the array.
 	 * @see xml2array(),array2xml()
 	 */
-	public static function array2xml_cs(array $array,$docTag='phparray',array $options=array(),$charset='')	{
+	public static function array2xml_cs(array $array, $docTag = 'phparray', array $options = array(), $charset = '') {
 
 			// Figure out charset if not given explicitly:
-		if (!$charset)	{
+		if (!$charset) {
-			if ($GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset'])	{	// First priority: forceCharset! If set, this will be authoritative!
+			if ($GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset']) { // First priority: forceCharset! If set, this will be authoritative!
 				$charset = $GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset'];
-			} elseif (is_object($GLOBALS['LANG']))	{
+			} elseif (is_object($GLOBALS['LANG'])) {
-				$charset = $GLOBALS['LANG']->charSet;	// If "LANG" is around, that will hold the current charset
+				$charset = $GLOBALS['LANG']->charSet; // If "LANG" is around, that will hold the current charset
 			} else {
-				$charset = 'iso-8859-1';	// THIS is just a hopeful guess!
+				$charset = 'iso-8859-1'; // THIS is just a hopeful guess!
 			}
 		}
 
 			// Return XML:
-		return '<?xml version="1.0" encoding="'.htmlspecialchars($charset).'" standalone="yes" ?>'.LF.
+		return '<?xml version="1.0" encoding="' . htmlspecialchars($charset) . '" standalone="yes" ?>' . LF .
-				self::array2xml($array,'',0,$docTag,0, $options);
+				self::array2xml($array, '', 0, $docTag, 0, $options);
 	}
 
 	/**
